#ifndef __Oracle_h__
#define __Oracle_h__

#include "Event.h"
#include "IOracle.h"

class Oracle : public IOracle
{
public:
    static IOracle::OracleChooser *_chooser;

    static Event choose( Vector<Event> enabledEvents )
    {
        return _chooser->choose( enabledEvents );
    }

    static void setChooser( IOracle::OracleChooser *chooser )
    {
        if ( chooser )
        {
            delete _chooser;
        }

        _chooser = chooser;
    }
};

#endif // __Oracle_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
