#ifndef __AbstractionData_h__
#define __AbstractionData_h__

#include "AbstractionFunction.h"
#include "ThreadStateGraph.h"
#include "Vector.h"

struct AbstractionData
{
    struct ModuleData
    {
        ModuleData( ThreadStateGraph *concrete, ThreadStateGraph *abstract, AbstractionFunction *abstractionFunction ) :
            _concrete( concrete ), _abstract( abstract ), _abstractionFunction( abstractionFunction )
        {
        }

        ThreadStateGraph *_concrete;
        ThreadStateGraph *_abstract;
        AbstractionFunction *_abstractionFunction;
    };

    Vector<AbstractionData::ModuleData> _abstractModules;
    ThreadStateGraph *_composedGraph;
};

#endif // __AbstractionData_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
