#ifndef __HttpDispatcherSimulator_h__
#define __HttpDispatcherSimulator_h__

#include "BThread.h"
#include "IEvent.h"

class HttpDispatcherSimulator : public BThread
{
public:
    void entryPoint()
    {
        while ( true )
        {
            waitForRequests();
            classifyRequest();
        }
    }

private:
    void waitForRequests()
    {
        clearEventVectors();

        _watched.append( IEvent::HTTP_DATA_RECEIVED );
        _blocked.append( IEvent::HTTP_GET_REQUEST );

        bSync( _requested, _watched, _blocked, "Wait" );
    }

    void classifyRequest()
    {
        clearEventVectors();

        _requested.append( IEvent::HTTP_GET_REQUEST );
        _requested.append( IEvent::HTTP_GENERATE_ERROR );
        _blocked.append( IEvent::HTTP_DATA_RECEIVED );

        bSync( _requested, _watched, _blocked, "Get" );
    }
};

#endif // __HttpDispatcherSimulator_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
