#ifndef __RawSocketSimulator_h__
#define __RawSocketSimulator_h__

class RawSocketSimulator : public BThread
{
public:
    RawSocketSimulator()
    {
    }

    void entryPoint()
    {
        while ( true )
        {
            requestDataReceived();

            while ( notDoneYet() )
            {
                waitForSendOrDone();

                if ( lastEvent().type() == IEvent::TCP_DONE_HANDLING_DATA )
                {
                    _busy = false;
                }
            }
        }
    }

private:
    bool _busy;

    void requestDataReceived()
    {
        clearEventVectors();
        _requested.append( IEvent::TCP_DATA_RECEIVED );
        bSync( _requested, _watched, _blocked, "Data" );

        _busy = true;
    }

    bool notDoneYet() const
    {
        return _busy;
    }

    void waitForSendOrDone()
    {
        clearEventVectors();
        _watched.append( IEvent::TCP_DONE_HANDLING_DATA );
        _watched.append( IEvent::TCP_SEND_DATA );
        _blocked.append( IEvent::TCP_DATA_RECEIVED );
        bSync( _requested, _watched, _blocked, "Wait" );
    }
};

#endif // __RawSocketSimulator_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
