#ifndef __BridgeToHttpSpanner_h__
#define __BridgeToHttpSpanner_h__

#include "BridgeToHttp.h"
#include "StateGraphSpanner.h"

class BridgeToHttpToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new BridgeToHttp;
    }
};

class BridgeToHttpSpanner
{
public:
    void eventsForBridgeToHttp( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForBridgeToHttp( stateGraph._events );

        BridgeToHttpToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "bridgeToHttp";
    }
};

#endif // __BridgeToHttpSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
