#ifndef __HttpGetSimulatorSpanner_h__
#define __HttpGetSimulatorSpanner_h__

#include "HttpGetSimulator.h"
#include "StateGraphSpanner.h"

class HttpGetSimulatorToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new HttpGetSimulator;
    }
};

class HttpGetSimulatorSpanner
{
public:
    void eventsForHttpGetSimulator( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForHttpGetSimulator( stateGraph._events );

        HttpGetSimulatorToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "httpGetSimulator";
    }
};

#endif // __HttpGetSimulatorSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
