#ifndef __TcpDispatcherSimulatorSpanner_h__
#define __TcpDispatcherSimulatorSpanner_h__

#include "TcpDispatcherSimulator.h"
#include "StateGraphSpanner.h"

class TcpDispatcherSimulatorToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new TcpDispatcherSimulator;
    }
};

class TcpDispatcherSimulatorSpanner
{
public:
    void eventsForTcpDispatcherSimulator( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForTcpDispatcherSimulator( stateGraph._events );

        TcpDispatcherSimulatorToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "tcpDispatcherSimulator";
    }
};

#endif // __TcpDispatcherSimulatorSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
